  MEMBER('PEOPLE.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
PEOPLBC0:DctInit    PROCEDURE
PEOPLBC0:DctKill    PROCEDURE
PEOPLBC0:FilesInit  PROCEDURE
  END

Hide:Access:people   CLASS(FileManager),TYPE               ! FileManager for people
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:people   CLASS(RelationManager),TYPE           ! RelationManager for people
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Hide:Access:SiteUse  CLASS(FileManager),TYPE               ! FileManager for SiteUse
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:SiteUse  CLASS(RelationManager),TYPE           ! RelationManager for SiteUse
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END


_Hide:Access:people  &Hide:Access:people,AUTO,THREAD
_Hide:Relate:people  &Hide:Relate:people,AUTO,THREAD
_Hide:Access:SiteUse &Hide:Access:SiteUse,AUTO,THREAD
_Hide:Relate:SiteUse &Hide:Relate:SiteUse,AUTO,THREAD


PEOPLBC0:DctInit PROCEDURE
  CODE
  _Hide:Access:people &= NEW(Hide:Access:people)
  _Hide:Relate:people &= NEW(Hide:Relate:people)
  _Hide:Access:SiteUse &= NEW(Hide:Access:SiteUse)
  _Hide:Relate:SiteUse &= NEW(Hide:Relate:SiteUse)
  Relate:people &= _Hide:Relate:people
  Relate:SiteUse &= _Hide:Relate:SiteUse


PEOPLBC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:people.Init
  _Hide:Relate:SiteUse.Init


PEOPLBC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:people.Kill
  DISPOSE(_Hide:Relate:people)
  _Hide:Relate:SiteUse.Kill
  DISPOSE(_Hide:Relate:SiteUse)


Hide:Relate:people.Init PROCEDURE
  CODE
  _Hide:Access:people.Init
  SELF.Init(Access:people,1)


Hide:Access:people.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= PEO:Record
  SELF.FileNameValue = 'people'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= people
  PARENT.Init
  Access:people &= SELF


Hide:Access:people.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:people &= NULL                                    ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:people.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(people,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(PEO:KeyId,'PEO:KeyId',1)
    SELF.AddKey(PEO:KeyLastName,'PEO:KeyLastName',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:people.Kill PROCEDURE

  CODE
  _Hide:Access:people.Kill                                 ! Kill the file manager
  PARENT.Kill
  Relate:people &= NULL                                    ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:people)                             ! destroy the file manager


Hide:Relate:SiteUse.Init PROCEDURE
  CODE
  _Hide:Access:SiteUse.Init
  SELF.Init(Access:SiteUse,1)


Hide:Access:SiteUse.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= STU:Record
  SELF.FileNameValue = 'SiteUse'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= SiteUse
  PARENT.Init
  Access:SiteUse &= SELF


Hide:Access:SiteUse.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:SiteUse &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:SiteUse.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(SiteUse,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(STU:k_Recd_nbr,'STU:k_Recd_nbr',1)
    SELF.AddKey(STU:k_Date,'STU:k_Date',0)
    SELF.AddKey(STU:k_PersonID,'STU:k_PersonID',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:SiteUse.Kill PROCEDURE

  CODE
  _Hide:Access:SiteUse.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:SiteUse &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:SiteUse)                            ! destroy the file manager

