#!============================================================
#! sdkLCS.tpl -- List Column Sorter class implementation
#!
#!  2010 Simon Kemp, simon@sdk.demon.co.uk
#!
#!  This software is provided 'as-is', without any express or implied
#!  warranty.  In no event will the author be held liable for any damages
#!  arising from the use of this software.
#!
#!  Permission is granted to anyone to use this software for any purpose,
#!  including commercial applications, and to alter it and redistribute it
#!  freely, subject to the following restrictions:
#!
#!  1. The origin of this software must not be misrepresented; you must not
#!     claim that you wrote the original software. If you use this software
#!     in a product, an acknowledgment in the product documentation would be
#!     appreciated but is not required.
#!
#!  2. Altered source versions must be plainly marked as such, and must not be
#!     misrepresented as being the original software.
#!
#!  3. This notice may not be removed or altered from any source distribution.
#!
#!============================================================
#TEMPLATE(SDKLCS,'SDK List Column Sorting'),FAMILY('cw20'),FAMILY('ABC')
#EXTENSION (Global,'Activate SDK List Column Sorting'),APPLICATION
#BOXED ('')
  #DISPLAY ('Column sorting for list boxes driven by simple queues')
  #DISPLAY ('(C6/C7 only). Version 1.2 June 2010.')
  #DISPLAY
  #DISPLAY ('This extension includes some source files and generates')
  #DISPLAY ('code in the app''s global map / data / procedure')
  #DISPLAY ('areas.')
  #DISPLAY
  #DISPLAY ('Add the procedure extension for each list box where')
  #DISPLAY ('you want to use Column Sorting. Avoid file browse')
  #DISPLAY ('list boxes!')
  #DISPLAY
  #BOXED ('Adjust List Control Lineheight')
    #PROMPT ('By',@s30), %LCSGloLineHeight
    #ENABLE(%LCSGloLineHeight)
      #PROMPT('Do it to',OPTION),%LCSGloLineHeightAction,DEFAULT(1),CHOICE
      #PROMPT('Sorted List controls only',RADIO)
      #PROMPT('All List Controls',RADIO)
    #ENDENABLE
  #ENDBOXED
#ENDBOXED

#AT(%BeforeGlobalIncludes)
  INCLUDE('sdkLCS.inc'),ONCE
#ENDAT

#AT (%BeforeWindowIniResize),PRIORITY(100)
#IF(%LCSGloLineHeight and %LCSGloLineHeightAction=2)
  #FOR(%Control),where(%ControlType = 'LIST')
%Control{PROP:LineHeight} = %Control{PROP:LineHeight} + %LCSGloLineHeight
  #ENDFOR
#ENDIF
#ENDAT

#EXTENSION(SDKLCSW, 'SDK List Column Sorting'), DESCRIPTION('Column sort ' & %LCSListBox & ' (' & %LCSObjectName & ')'),MULTI,PROCEDURE,REQ(Global)
    #BOXED('')
      #PROMPT ('Object Name',@s50),%LCSObjectName,DEFAULT('ListColumnSorter' & %ActiveTemplateInstance),REQ
      #PROMPT ('Control', FROM (%Control, %ControlFrom <> '')), %LCSListBox, REQ
      #PROMPT ('Adjust List lineheight by',@s30), %LCSLineHeight
      #PROMPT ('CURSOR:Wait during Sorts', CHECK), %LCSCursorWait, DEFAULT(%True), AT(10)
      #PROMPT ('Sort when CHANGES() detected', CHECK), %LCSSortOnChanges, DEFAULT(%True), AT(10)
      #PROMPT ('Enable Multi-Column Sorting', CHECK), %LCSMultiKey, DEFAULT(%True), AT(10)
      #PROMPT ('Sort Indicators before header text', CHECK), %LCSPrependIndicators, DEFAULT(%False), AT(10)
      #PROMPT ('Header "button effect" (beta)', CHECK), %LCSHeaderEffects, DEFAULT(%False), AT(10)
      #BOXED('Initial Sort')
        #PROMPT ('Enable', CHECK), %LCSInitialSortON, DEFAULT(%False), AT(10)
        #ENABLE(%LCSInitialSortON)
        #PROMPT ('Lock (ignore header clicks)', CHECK), %LCSInitialSortLocked, DEFAULT(%False), AT(10)
          #BOXED ('')
            #PROMPT ('Variable', CHECK), %LCSInitialVariableON, DEFAULT(%False), AT(10)
            #ENABLE(%LCSInitialVariableON = %True)
              #PROMPT ('Variable Name',@s30),%LCSInitialSort,REQ
            #ENDENABLE
          #ENDBOXED
          #ENABLE(%LCSInitialVariableON = %False)
            #PREPARE
              #DECLARE(%ListCols),MULTI
              #DECLARE(%ListColCount,LONG)
              #SET(%ListColCount,0)
              #FIX(%Control,%LCSListBox)
              #FOR(%ControlField)
                #SET(%ListColCount,%ListColCount+1)
                #ADD(%ListCols,format(%ListColCount,@s4) & ' ' & %ControlFieldHeader)
              #ENDFOR
            #ENDPREPARE
            #BOXED ('')
              #PROMPT ('Column', FROM (%ListCols)), %LCSInitialSortColumn
              #PROMPT ('Reverse Order', CHECK), %LCSInitialSortColumnReverse, DEFAULT(%False), AT(10)
              #PROMPT ('OR enter manually here', @s30), %LCSInitialSortManual
            #ENDBOXED
          #ENDENABLE
        #ENDENABLE
      #ENDBOXED
      #BOXED('Column Options')
        #PREPARE
          #DECLARE(%BlockSortColumns),MULTI
          #IF(sub(%CWVersion,1,1) = '7')
            #ADD(%BlockSortColumns,'')
          #ENDIF  
          #FIX(%Control,%LCSListBox)
          #FOR(%ControlField)
            #ADD(%BlockSortColumns,format(instance(%ControlField),@s4) & ' ' & %ControlFieldHeader)
          #ENDFOR
        #ENDPREPARE
        #PROMPT('Block All Sorting',FROM(%BlockSortColumns)),%LCSBlockSort,SELECTION('Block All Sorting')
        #PREPARE
          #DECLARE(%CaseSensitiveSortColumns),MULTI
          #IF(sub(%CWVersion,1,1) = '7')
            #ADD(%CaseSensitiveSortColumns,'')
          #ENDIF  
          #FIX(%Control,%LCSListBox)
          #FOR(%ControlField)
            #ADD(%CaseSensitiveSortColumns,format(instance(%ControlField),@s4) & ' ' & %ControlFieldHeader)
          #ENDFOR
        #ENDPREPARE
        #PROMPT('Case Sensitive Strings',FROM(%CaseSensitiveSortColumns)),%LCSCaseSensitive,SELECTION('Case Sensitive Strings')
        #PREPARE
          #DECLARE(%NoForwardSortColumns),MULTI
          #IF(sub(%CWVersion,1,1) = '7')
            #ADD(%NoForwardSortColumns,'')
          #ENDIF  
          #FIX(%Control,%LCSListBox)
          #FOR(%ControlField)
            #ADD(%NoForwardSortColumns,format(instance(%ControlField),@s4) & ' ' & %ControlFieldHeader)
          #ENDFOR
        #ENDPREPARE
        #PROMPT('Block Sort [+]',FROM(%NoForwardSortColumns)),%LCSNoForward,SELECTION('Block Sort [+]')
        #PREPARE
          #DECLARE(%NoReverseSortColumns),MULTI
          #IF(sub(%CWVersion,1,1) = '7')
            #ADD(%NoReverseSortColumns,'')
          #ENDIF  
          #FIX(%Control,%LCSListBox)
          #FOR(%ControlField)
            #ADD(%NoReverseSortColumns,format(instance(%ControlField),@s4) & ' ' & %ControlFieldHeader)
          #ENDFOR
        #ENDPREPARE
        #PROMPT('Block Sort [-]',FROM(%NoReverseSortColumns)),%LCSNoReverse,SELECTION('Block Sort [-]')
        #PROMPT ('Override Column Fields:',@s128),%LCSoverridecolumnfields
      #ENDBOXED
    #ENDBOXED

#ATSTART
#DECLARE(%tmpColNumber)
#DECLARE(%tmpSortPar1)
#DECLARE(%tmpSortPar2)
#DECLARE(%tmpDisableSort)
#DECLARE(%tmpNoCase)
#DECLARE(%tmpRestrictSort)
#DECLARE(%tmpLineHeight)
#ENDAT

#AT(%DataSectionBeforeWindow)
%LCSObjectName sdkLCS
#ENDAT

#AT (%BeforeWindowIniResize),PRIORITY(200)
#FOR (%Control), WHERE(%Control = %LCSListBox)
  #IF(%LCSLineHeight)
    #SET(%tmpLineHeight,%LCSLineHeight)
  #ELSIF(%LCSGloLineHeight and %LCSGloLineHeightAction=1)
    #SET(%tmpLineHeight,%LCSGloLineHeight)
  #ELSE
    #SET(%tmpLineHeight,'')
  #END
#ENDFOR
#ENDAT
#AT (%PrepareAlerts)
#FOR (%Control), WHERE(%Control = %LCSListBox)
%LCSObjectName.Init(%Control, %ControlFrom, %tmpLineHeight)
  #SET(%tmpColNumber,0)
  #SET(%tmpDisableSort,ALL('0',%ListColCount))
  #FOR(%LCSBlockSort), WHERE(slice(%LCSBlockSort,1,3)>0)
    #SET(%tmpColNumber,slice(%LCSBlockSort,1,3))
    #SET(%tmpDisableSort,sub(%tmpDisableSort,1,%tmpColNumber-1) & 1 & sub(%tmpDisableSort,%tmpColNumber+1,255))
  #ENDFOR
  #IF (%tmpDisableSort <> ALL('0',%ListColCount))
    #SET(%tmpDisableSort,'''' & %tmpDisableSort & '''')
  #ELSE
    #SET(%tmpDisableSort,'')
  #ENDIF
  #SET(%tmpColNumber,0)
  #SET(%tmpNoCase,ALL('0',%ListColCount))
  #FOR(%LCSCaseSensitive), WHERE(slice(%LCSCaseSensitive,1,3)>0)
    #SET(%tmpColNumber,slice(%LCSCaseSensitive,1,3))
    #SET(%tmpNoCase, sub(%tmpNoCase,1,%tmpColNumber-1) & 1 & sub(%tmpNoCase,%tmpColNumber+1,255))
  #ENDFOR
  #IF (%tmpNoCase <> ALL('0',%ListColCount))
    #SET(%tmpNoCase,'''' & %tmpNoCase & '''')
  #ELSE
    #SET(%tmpNoCase,'')
  #ENDIF
  #SET(%tmpColNumber,0)
  #SET(%tmpRestrictSort,ALL('0',%ListColCount))
  #FOR(%LCSNoForward), WHERE(slice(%LCSNoForward,1,3)>0)
    #SET(%tmpColNumber,slice(%LCSNoForward,1,3))
    #SET(%tmpRestrictSort, sub(%tmpRestrictSort,1,%tmpColNumber-1) & 2 & sub(%tmpRestrictSort,%tmpColNumber+1,255))
  #ENDFOR
  #SET(%tmpColNumber,0)
  #FOR(%LCSNoReverse), WHERE(slice(%LCSNoReverse,1,3)>0)
    #SET(%tmpColNumber,slice(%LCSNoReverse,1,3))
    #SET(%tmpRestrictSort, sub(%tmpRestrictSort,1,%tmpColNumber-1) & sub(%tmpRestrictSort,%tmpColNumber,1) + 1 & sub(%tmpRestrictSort,%tmpColNumber+1,255))
  #ENDFOR
  #IF (%tmpRestrictSort <> ALL('0',%ListColCount))
    #SET(%tmpRestrictSort,'''' & %tmpRestrictSort & '''')
  #ELSE
    #SET(%tmpRestrictSort,'')
  #ENDIF
#IF (%tmpDisableSort or %tmpNoCase or %tmpRestrictSort or %LCSoverridecolumnfields)
%LCSObjectName.SetColumnOptions(%tmpDisableSort, %tmpNoCase, %tmpRestrictSort, %LCSoverridecolumnfields)
#ENDIF
#IF (%LCSPrependIndicators=%True)
%LCSObjectName.prependindicators = true
#ENDIF
#IF (%LCSSortOnChanges=%False)
%LCSObjectName.sortonchanges = false
#ENDIF
#IF (%LCSCursorWait=%False)
%LCSObjectName.showcursoronsort = false
#ENDIF
#IF (%LCSMultiKey<>%True)
%LCSObjectName.multikey = false
#ENDIF
#IF (%LCSHeaderEffects=%True)
%LCSObjectName.headereffects = true
#ENDIF
  #IF (%LCSInitialSortON)
    #IF (%LCSInitialVariableON)
      #SET(%tmpSortPar1,%LCSInitialSort)
    #ELSE
      #IF (%LCSInitialSortManual)
        #SET(%tmpSortPar2,%LCSInitialSortManual)
      #ELSIF (%LCSInitialSortColumnReverse)
        #SET(%tmpSortPar2,'-' & clip(SLICE(%LCSInitialSortColumn,1,3)))
      #ELSE
        #SET(%tmpSortPar2,'+' & clip(SLICE(%LCSInitialSortColumn,1,3)))
      #ENDIF
    #ENDIF
%LCSObjectName.SetInitialSort(%tmpSortPar1, '%tmpSortPar2', %LCSInitialSortLocked)
  #END
#EMBED(%SDKLCSEmbeds,'SDKLCS'),%LCSObjectName,'Before .start'
%LCSObjectName.Start
#ENDFOR
#ENDAT

#AT (%AcceptLoopBeforeEventHandling)
if %LCSObjectName.TakeEvent()
  cycle
end
#ENDAT

